Description

When using Foreman strictly as a reporting tool, the individual host view doesn't display the values for Domain, Puppet Environment,
Host Architecture, Host Operating System, or Host Group, even though facts are available for all of them. I'll see if | can put together
a patch that will only pull the facts in if the system isn't otherwise configured.

Associated revisions

Revision 38dbbddf - 01/20/2011 05:03 AM - Ohad Levy
fixes #335 - this patch will auto import the facts (making the rake task or import_facts script redundent).
this patch introduce a new settings options :using_storeconfigs:

while we try to automaticily detect if we run storeconfigs, its not always possible
when foreman is not running on the same host as the puppetmaster.

History

#1 - 07/01/2010 07:21 PM - Ohad Levy

- Status changed from New to Feedback

- Target version deleted (0.1-6)

this is not really a bug, but rather that foreman has not been configured to fetch the facts from puppet.
see the rake fact importer tasks (or populate task if you are using storeconfigs) or the import_facts scripts.
#2 - 07/01/2010 09:34 PM - Brian Gallew

- File facts_as_necessary.diff added

- Target version set to 0.1-6
Attached is a diff that will use the values from host.fv() if the appropriate values are not set for the host (e.g. host.domain). This patch is against 0.1-5.
#3 - 07/01/2010 09:56 PM - Brian Gallew
Ohad Levy wrote:

this is not really a bug, but rather that foreman has not been configured to fetch the facts from puppet.

see the rake fact importer tasks (or populate task if you are using storeconfigs) or the import_facts scripts.
I'm using storeconfigs and I've run the importer task. I've never seen any documentation pointing to a populate task. Reading the rakefile, that
doesn't touch any of the fields that Foreman generally manages (domain, arch, os, model, and environment). And again, if you aren't using Foreman

to manage that data, then nothing is displayed in either the _overview or _minilist. The diff I've attached will only affect the display when the
associated host.whatever field is empty, and doesn't touch the DB.

#4 - 08/15/2010 12:54 PM - Ohad Levy

I'm willing to accept the patch, but it seems like a lot of repetition between the fact importer code...
Do you think it might be better to update the docs so other people wont have the same problem as you do? (IMHO it would also be faster not to query
the facts directly).

#5 - 08/20/2010 01:11 AM - Brian Gallew

| have to admit that 9 lines of code (replacing 5 existing lines) doesn't seem like a lot of repetition to me. OTOH, if the fact importer code is already
supposed to be importing data from the hosts, maybe it makes sense for me to look there and patch that to populate the Foreman tables when there
is no existing data? If that's what it would take to make an acceptable patch, | can work on it.

#6 - 08/28/2010 09:44 PM - Ohad Levy

Brian Gallew wrote:

| have to admit that 9 lines of code (replacing 5 existing lines) doesn't seem like a lot of repetition to me. OTOH, if the fact importer code is
already supposed to be importing data from the hosts, maybe it makes sense for me to look there and patch that to populate the Foreman tables
when there is no existing data? If that's what it would take to make an acceptable patch, | can work on it.

Sorry for the late response.
Yes, thats what | meant, it makes far more sense to make sure we import the data correctly.
(its also important for other usage cases - so imho - it would be better).

thanks

#7 - 08/29/2010 03:05 PM - Brian Gallew

OK, I'll get this refactored and submit a new patch. It'll take me a few days, probably.

#8 - 09/20/2010 10:09 AM - Ohad Levy

| think this issue is resolved after the fix for #336, can you confirm?

#9 - 10/01/2010 10:58 PM - Brian Gallew

Assuming this fix is in the latest snapshots, then no. However, it occurs
to me that | may not have been specific enough when | created this ticket.
I don't run @ manual yaml import. Rather, | expect that the clients which
are reporting to Foreman via the "report=foreman" line in puppet.conf will
have correct information if for these fields if they are not explicitly
pre-populated.

#10 - 10/03/2010 05:32 AM - Ohad Levy

Brian Gallew wrote:

Assuming this fix is in the latest snapshots, then no. However, it occurs
to me that | may not have been specific enough when | created this ticket.
| don't run a manual yaml import. Rather, | expect that the clients which
are reporting to Foreman via the "report=foreman" line in puppet.conf will
have correct information if for these fields if they are not explicitly
pre-populated.

The report information does not contain any facts...

Foreman can collect facts from the filesystem (via ~puppet/yaml/facts) or via storeconfigs (if sharing the same db).
then based on the facts, additional information is extracted (like os) to populate additional tables in the db...

So I'm not really sure | understand what you want to solve...

#11 - 10/17/2010 02:50 PM - Ohad Levy
- Target version deleted (0.1-6)

#12 - 10/25/2010 11:14 PM - Brian Gallew
- File foreman_info.patch added

- Target version set to 0.2

I've got a brand-new patch for you. The behavioral changes are all controlled by a new settings.yaml value ":reportonly: true". If :reportonly is set to
any other value (or missing) then Foreman behaves as before. If set to "true", then every time a client reports, Foreman will update the environment,
OS, and model with values derived from Puppet facts.

You should discard the previous patch.
#13 - 10/26/2010 12:30 AM - Brian Gallew

- File foreman_info.patch added

Having multiple copies of a patch file laying around occasionally causes problems. Sorry.

#14 - 10/26/2010 09:07 AM - Ohad Levy
- Assignee changed from Ohad Levy to Brian Gallew
Brian Gallew wrote:

Having multiple copies of a patch file laying around occasionally causes problems. Sorry.

I'm not sure | understand why you do it in the report model, the data that you process are facts, which are imported (if using storeconfigs), using the
Host.importFacts method.

that means,that if a report came before its facts, then there would be no data to import from.

if | understand correctly, what you are asking, is basically item 1 in http:/theforeman.org/issues/284#note-4

#15 - 10/28/2010 06:54 PM - Brian Gallew

Except that, without my patch, Foreman is not pulling in the host facts when using storeconfig unless you have a separate rake task. If | delete hosts
from my Foreman instance and change the config setting, then the hosts, when displayed in the "Hosts" view as well as the individual host pages,
have no information on Environment, Model, or OS.

#16 - 10/28/2010 07:07 PM - Ohad Levy

Brian Gallew wrote:
Except that, without my patch, Foreman is not pulling in the host facts when using storeconfig unless you have a separate rake task. If | delete
hosts from my Foreman instance and change the config setting, then the hosts, when displayed in the "Hosts" view as well as the individual host
pages, have no information on Environment, Model, or OS.

Why dont you run the cronjob as described in Puppet_Facts?

there are also examples of it in the foreman puppet module

#17 - 10/28/2010 10:27 PM - Brian Gallew

If you advocate running the cron job, then why waste time supporting a web reporting interface? The whole point of web reporting is, "update the
database/GUI with current information". While Model and OS won't change very often, my environments frequently do. Why shouldn't the web
reporting interface update all the same information as the cron job? Does the value of the information change depending on the source?

#18 - 11/09/2010 09:40 AM - Ohad Levy

Brian Gallew wrote:
If you advocate running the cron job, then why waste time supporting a web reporting interface? The whole point of web reporting is, "update the

database/GUI with current information”. While Model and OS won't change very often, my environments frequently do. Why shouldn't the web
reporting interface update all the same information as the cron job? Does the value of the information change depending on the source?

the main difference is:

Puppet reporting interface is plugable, i.e when a report is sent to puppet, we can simply forward it to foreman and process it,

Puppet facts however don't have such an interface, and we don't know when a new fact is being collected.

at the moment, we support two different approches, based on weather or not you use storeconfigs.

using storeconfigs

when using storeconfigs, puppet itself will update the database, making foreman completly unaware of it.

for this problem, we've created the populate rake task, which basicilly reimport the facts into the fields foreman is interested in, now that | think of it a
bit more, we could have a setting option letting us know if you use storeconfigs or not, and upon new report, also import the fields from the db.

not using storeconfigs

here we have a simple script which runs in cron, checking the time stamp of the fact yaml files, and send new ones every run

05/13/2024 3/4


http://theforeman.org/issues/284#note-4
https://projects.theforeman.org/projects/foreman/wiki/Puppet_Facts

#19 - 12/26/2010 05:26 AM - Ohad Levy
- Status changed from Feedback to Assigned

- Assignee changed from Brian Gallew to Ohad Levy

Does the following sounds like an acceptable solution:

if using Storeconfigs, then auto import the host facts once a report comes in?

#20 - 01/20/2011 05:07 AM - Ohad Levy
- Status changed from Assigned to Ready For Testing
- % Done changed from 0 to 100

Applied in changeset 38dbbddf5b45b39e23a53df9ec69c17b90e3c5b4.

#21 - 01/21/2011 12:44 PM - Brian Gallew
Thanks, that'll be very helpful.

#22 - 01/21/2011 12:47 PM - Ohad Levy

Brian Gallew wrote:

Thanks, that'll be very helpful.

Can you confirm that its behaving as you expect? - thanks

#23 - 01/24/2011 03:18 PM - Ohad Levy
- Status changed from Ready For Testing to Closed
